#include<bits/stdc++.h>
using namespace std;

int main()
{
    ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    int t,n,m;
    long long g;
    cin >> t;
    for (int i=0;i<t;i++)
    {
        cin >> n >> m;
        bool provera=true;
        vector<long long> niz(n);
        vector<long long> nizProvera(m);
        for (int i=0;i<n;i++)
            cin >> niz[i];
        for (int i=0;i<m;i++)
            cin >> nizProvera[i];
        sort(niz.begin(),niz.end());
        g=niz[n-1]-niz[0];
        for (int i=1;i<n;i++)
            g=__gcd(niz[i]-niz[i-1],g);
        for (int i=0;i<m;i++)
            if(abs(nizProvera[i]-niz[0])%g==0)
                {provera=false;break;}
        if(provera)
            cout << 1 << '\n';
        else
            cout << 0 << '\n';
    }
}